/*
 *    Copyright (c) 2018-2025, lengleng All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 * Neither the name of the yifu4cloud.com developer nor the names of its
 * contributors may be used to endorse or promote products derived from
 * this software without specific prior written permission.
 * Author: lengleng (wangiegie@gmail.com)
 */

package com.yifu.cloud.plus.v1.yifu.social.controller;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.yifu.cloud.plus.v1.yifu.common.core.constant.CommonConstants;
import com.yifu.cloud.plus.v1.yifu.common.core.util.ErrorMessage;
import com.yifu.cloud.plus.v1.yifu.common.core.util.R;
import com.yifu.cloud.plus.v1.yifu.common.core.util.bean.BeanCopyUtils;
import com.yifu.cloud.plus.v1.yifu.common.core.vo.YifuUser;
import com.yifu.cloud.plus.v1.yifu.common.dapr.util.MenuUtil;
import com.yifu.cloud.plus.v1.yifu.common.log.annotation.SysLog;
import com.yifu.cloud.plus.v1.yifu.common.mybatis.base.BaseEntity;
import com.yifu.cloud.plus.v1.yifu.common.security.annotation.Inner;
import com.yifu.cloud.plus.v1.yifu.common.security.util.SecurityUtils;
import com.yifu.cloud.plus.v1.yifu.social.entity.SysBaseSetInfo;
import com.yifu.cloud.plus.v1.yifu.social.entity.SysPayProportion;
import com.yifu.cloud.plus.v1.yifu.social.service.SysBaseSetInfoService;
import com.yifu.cloud.plus.v1.yifu.social.service.SysPayProportionService;
import com.yifu.cloud.plus.v1.yifu.social.vo.SysBaseSetInfoSearchVo;
import com.yifu.cloud.plus.v1.yifu.social.vo.SysBaseSetInfoVo;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import lombok.RequiredArgsConstructor;
import lombok.SneakyThrows;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.util.List;


/**
 * 基数设置表
 *
 * @author hgw
 * @date 2022-07-11 18:21:23
 */
@RestController
@RequiredArgsConstructor
@RequestMapping("/sysbasesetinfo")
@Tag(name = "基数设置表管理")
public class SysBaseSetInfoController {

	private final SysBaseSetInfoService sysBaseSetInfoService;
	private final SysPayProportionService sysPayProportionService;
	private final MenuUtil menuUtil;


	/**
	 * 简单分页查询---自动化专用
	 *
	 * @param page           分页对象
	 * @param sysBaseSetInfo 基数设置表
	 * @return
	 */
	@Operation(summary = "分页查询", description = "分页查询")
	@GetMapping("/page")
	public R<IPage<SysBaseSetInfo>> getSysBaseSetInfoPage(Page<SysBaseSetInfo> page, SysBaseSetInfo sysBaseSetInfo) {
		YifuUser user = SecurityUtils.getUser();
		menuUtil.setAuthSql(user, sysBaseSetInfo);
		return new R<>(sysBaseSetInfoService.getSysBaseSetInfoPage(page, sysBaseSetInfo));
	}

	/**
	 * 简单分页查询
	 *
	 * @param page           分页对象
	 * @param sysBaseSetInfo 基数设置表
	 * @return
	 */
	@Operation(summary = "分页查询", description = "分页查询")
	@GetMapping("/pageAsso")
	public R<IPage<SysBaseSetInfo>> getSysBaseSetInfoPageAsso(Page<SysBaseSetInfo> page, SysBaseSetInfo sysBaseSetInfo) {
		return new R<>(sysBaseSetInfoService.getSysBaseSetInfoPageAsso(page, sysBaseSetInfo));
	}

	/**
	 * 不分页查询
	 *
	 * @param sysBaseSetInfo 基数设置表
	 * @return
	 */
	@Operation(summary = "不分页查询", description = "不分页查询")
	@PostMapping("/noPage")
	public R<List<SysBaseSetInfo>> getSysBaseSetInfoNoPage(@RequestBody SysBaseSetInfo sysBaseSetInfo) {
		return R.ok(sysBaseSetInfoService.list(Wrappers.query(sysBaseSetInfo).orderByDesc(CommonConstants.CREATE_TIME)));
	}

	/**
	 * 通过id查询基数设置表
	 *
	 * @param id id
	 * @return R
	 */
	@Operation(summary = "通过id查询", description = "通过id查询")
	@GetMapping("/{id}")
	public R<SysBaseSetInfo> getById(@PathVariable("id") String id) {
		SysBaseSetInfo baseSetInfo = sysBaseSetInfoService.getById(id);
		if (null != baseSetInfo && CommonConstants.ONE_STRING.equals(baseSetInfo.getBaseType())){
			baseSetInfo.setFundProList(sysPayProportionService.list(Wrappers.<SysPayProportion>query().lambda().eq(SysPayProportion::getSysBaseSetId,id)));
		}
		return R.ok(baseSetInfo);
	}

	/**
	 * 通过户名称查询基数设置表
	 *
	 * @param houseHoldName  户名称
	 * @param  type    类型  0.社保 1.公积金
	 * @return R
	 */
	@Operation(summary = "通过户名称查询", description = "通过户名称查询:type(0.社保 1.公积金) houseHoldName（社保户或公积金名称）")
	@GetMapping("/getBaseSetByParam")
	public R<SysBaseSetInfo> getBaseSetByParam(@RequestParam(name = "houseHoldName") String houseHoldName,
											   @RequestParam(name = "type") String type) {
		// 在用 非删除 最近创建的一条配置数据
		SysBaseSetInfo baseSetInfo = sysBaseSetInfoService.getOne(Wrappers.<SysBaseSetInfo>query().lambda()
				.eq(SysBaseSetInfo::getDepartName,houseHoldName).eq(SysBaseSetInfo::getBaseType,type)
				.eq(SysBaseSetInfo::getDeleteFlag,CommonConstants.ZERO_STRING)
				.eq(SysBaseSetInfo::getStatus,CommonConstants.ZERO_STRING)
				.orderByDesc(BaseEntity::getCreateTime)
				.last(CommonConstants.LAST_ONE_SQL));
		if (null != baseSetInfo && CommonConstants.ONE_STRING.equals(baseSetInfo.getBaseType())){
			baseSetInfo.setFundProList(sysPayProportionService.list(Wrappers.<SysPayProportion>query().lambda()
					.eq(SysPayProportion::getSysBaseSetId,baseSetInfo.getId())));
		}
		return R.ok(baseSetInfo);
	}

	/**
	 * 新增基数设置表
	 *
	 * @param sysBaseSetInfo 基数设置表
	 * @return R
	 */
	@Operation(summary = "新增基数设置表", description = "新增基数设置表：hasPermission('social_sysbasesetinfo_add')")
	@SysLog("新增基数设置表")
	@PostMapping
	@PreAuthorize("@pms.hasPermission('social_sysbasesetinfo_add')")
	public R<String> save(@RequestBody SysBaseSetInfo sysBaseSetInfo) {
		return sysBaseSetInfoService.saveSysBase(sysBaseSetInfo);
	}

	/**
	 * 修改基数设置表
	 *
	 * @param sysBaseSetInfo 基数设置表
	 * @return R
	 */
	@Operation(summary = "修改基数设置表", description = "修改基数设置表：hasPermission('social_sysbasesetinfo_edit')")
	@SysLog("修改基数设置表")
	@PutMapping
	@PreAuthorize("@pms.hasPermission('social_sysbasesetinfo_edit')")
	public R<String> updateById(@RequestBody SysBaseSetInfo sysBaseSetInfo) {
		return sysBaseSetInfoService.updateSysBase(sysBaseSetInfo);
	}

	/**
	 * 通过id删除基数设置表
	 *
	 * @param id id
	 * @return R
	 */
	@Operation(summary = "通过id删除基数设置表", description = "通过id删除基数设置表：hasPermission('social_sysbasesetinfo_del')")
	@SysLog("通过id删除基数设置表")
	@DeleteMapping("/{id}")
	@PreAuthorize("@pms.hasPermission('social_sysbasesetinfo_del')")
	public R<Boolean> removeById(@PathVariable String id) {
		return R.ok(sysBaseSetInfoService.removeById(id));
	}

	/**
	 * 通过id禁用启用一条记录
	 * @param id
	 * @return R
	 */
	@Operation(summary = "启用禁用", description = "启用禁用：hasPermission('social_sysbasesetinfo_enable') 0.在用 1.终止 2.过期")
	@SysLog("禁用启用基数设置表")
	@PostMapping("/disableOrEnableById")
	@PreAuthorize("@pms.hasPermission('social_sysbasesetinfo_enable')")
	public R<Boolean> disableOrEnableById(@RequestParam String id, @RequestParam Integer status) {
		return sysBaseSetInfoService.updateByIdAsso(id,status);
	}
	/**
	 * 通过id查询基数设置表--内部接口
	 *
	 * @param houseId
	 * @return R
	 */
	@Operation(summary = "通过id查询", description = "通过id查询")
	@Inner
	@PostMapping("/inner/getSocialHouseBaseSet")
	public SysBaseSetInfoVo getSocialHouseBaseSet(@RequestBody String houseId) {
		SysBaseSetInfo baseSetInfo = sysBaseSetInfoService.getById(houseId);
		if (null != baseSetInfo && CommonConstants.ONE_STRING.equals(baseSetInfo.getBaseType())){
			baseSetInfo.setFundProList(sysPayProportionService.list(Wrappers.<SysPayProportion>query().lambda().eq(SysPayProportion::getSysBaseSetId,houseId)));
		}
		SysBaseSetInfoVo sysBaseSetInfoVo = new SysBaseSetInfoVo();
		BeanCopyUtils.copyProperties(baseSetInfo,sysBaseSetInfoVo);
		return sysBaseSetInfoVo;
	}
	/**
	 * 基数设置表 批量导入社保基数
	 *
	 * @author fxj
	 * @Date 2025-11-04 14:50:51
	 **/
	@SneakyThrows
	@Operation(description = "批量新增社保基数设置表")
	@SysLog("批量新增社保基数设置表")
	@PostMapping("/importListAddSocial")
	@PreAuthorize("@pms.hasPermission('social_sysbasesetinfo_batch_add')")
	public R<List<ErrorMessage>> importListAddSocial(@RequestBody MultipartFile file){
		return sysBaseSetInfoService.importSocialDiy(file.getInputStream());
	}

	/**
	 * 基数设置表 批量导出社保基数
	 * @author fxj
	 * @Date 2025-11-04 14:50:51
	 **/
	@Operation(description = "导出社保基数设置表")
	@PostMapping("/exportSocial")
	@PreAuthorize("@pms.hasPermission('social_sysbasesetinfo_export')")
	public void exportSocial(HttpServletResponse response, @RequestBody SysBaseSetInfo searchVo) {
		YifuUser user = SecurityUtils.getUser();
		menuUtil.setAuthSql(user, searchVo);
		sysBaseSetInfoService.listSocialExport(response,searchVo);
	}

	/**
	 * 基数设置表 批量导入公积金基数
	 *
	 * @author fxj
	 * @Date 2025-11-04 14:50:51
	 **/
	@SneakyThrows
	@Operation(description = "批量新增公积金基数设置表")
	@SysLog("批量新增公积金基数设置表")
	@PostMapping("/importListAddFund")
	@PreAuthorize("@pms.hasPermission('fund_sysbasesetinfo_batch_add')")
	public R<List<ErrorMessage>> importListAddFund(@RequestBody MultipartFile file){
		return sysBaseSetInfoService.importFundDiy(file.getInputStream());
	}

	/**
	 * 基数设置表 批量导出公积金基数
	 * @author fxj
	 * @Date 2025-11-04 14:50:51
	 **/
	@Operation(description = "导出公积金基数设置表")
	@PostMapping("/exportFund")
	@PreAuthorize("@pms.hasPermission('fund_sysbasesetinfo_export')")
	public void exportFund(HttpServletResponse response, @RequestBody SysBaseSetInfo searchVo) {
		YifuUser user = SecurityUtils.getUser();
		menuUtil.setAuthSql(user, searchVo);
		sysBaseSetInfoService.listFundExport(response,searchVo);
	}
}
